/* CalFolder internal component - Copyright (C) 2005 Rod Whiteley - Licensed under the Open Software License version 2.1 - Source at http://calendarhelp.mozdev.org/calfolder.html */
CalfoModule = {
_class: "@mozilla.org/commandlinehandler/general-startup;1?type=calfo-report",_ID: Components.ID("{1884fd2c-c991-95e8-fa1c-c301d36664b6}"),_name: "Calendar Folders Startup",_argCat: "command-line-argument-handlers",_argEnt: "calfo report",_cmdCat: "command-line-handler",_cmdEnt: "n-report",factory: {
createInstance: function (outer, iid) {
if (outer == null) return CalfoModule.service
throw Components.results.NS_ERROR_NO_AGGREGATION}},service: {
QueryInterface : function service_qi(iid) {
if (iid.equals(Components.interfaces.nsISupports)
|| iid.equals(Components.interfaces.nsICommandLineHandler))
return this
throw Components.results.NS_ERROR_NO_INTERFACE},handle: function (cmdLine) {
cmdLine.preventDefault |= (cmdLine.state != cmdLine.STATE_INITIAL_LAUNCH)
var name = null
try {name = cmdLine.handleFlagWithParam("report", false)} catch (ex) {}
if (!name) return
var w = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("calendarMainWindow")
if (!w) return
var calfo = w.CalFolder
var folder = null
for each (var f in calfo.folders) {
if (calfo.data.getName(f.res) == name) {
folder = f
break}}
if (!folder) return
dump(">> folder is: " + folder.res.Value + "\n")
var IO = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService)
var ch = IO.newChannel("chrome://calfolder/content/report.xul", "utf-8", null)
var dp = Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser)
var doc = dp.parseFromStream(ch.open(), null, 0xffff, "text/xml")
Components.classes["@mozilla.org/moz/jssubscript-loader;1"].createInstance(Components.interfaces.mozIJSSubScriptLoader).loadSubScript("chrome://calfolder/content/report.js")
dump(">> wizard: " + CalfoWizard + "\n")
opener = w
document = doc
window = {arguments: [folder.res]}
CalfoWizard.init()
return},helpInfo : " -report name Run the named folder's default report.\n"},registerSelf: function (compMgr, fileSpec, location, type) {
compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar).registerFactoryLocation(
this._ID,this._name,this._class,fileSpec,location,type)
with (Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager)) {
addCategoryEntry(this._argCat, this._argEnt, this._ID, true, true)
addCategoryEntry(this._cmdCat, this._cmdEnt, this._ID, true, true)}},unregisterSelf: function(compMgr, fileSpec, location) {
compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar).unregisterFactoryLocation(this._ID, fileSpec)
with (Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager)) {
deleteCategoryEntry(this._argCat, this._argEnt, true)
deleteCategoryEntry(this._cmdCat, this._cmdEnt, true)}},getClassObject: function (compMgr, cid, iid) {
if (cid.equals(this._ID)) return this.factory
else throw Components.results.NS_ERROR_NO_INTERFACE},canUnload: function(compMgr) {return true}}
NSGetModule = function (compMgr, fileSpec) {return CalfoModule}
