/* CalFolder internal component - Copyright (C) 2005 Rod Whiteley - Licensed under the Open Software License version 2.1 - Source at http://calendarhelp.mozdev.org/calfolder.html */
CalFolder = {
uuid: "{ca1f01de-441c-6bb8-7900-517f3463cd03}",version: "",once: false,tree: null,body: null,tabs: null,clock: null,inhibit: false,defaultColor: "f9f4ff",folders: {},init: function () {
if (this.once) return
this.once = true
this.tree = document.getElementById("calfo-tree")
this.body = document.getElementById("calfo-children")
this.tabs = document.getElementById("tablist").firstChild
var tabIndex = this.tabs.parentNode.getAttribute("selectedIndex") || 0
this.entry.prototype = this.entry_prototype
this.folder.prototype = this.folder_prototype
this.pref.init()
this.color.init()
this.context.init()
this.rename.init()
this.drag.init()
this.prompt.init()
this.sandbox.init()
var pans = this.tabs.nextSibling
var pan = pans.firstChild
var tab = this.tabs.firstChild
while (pan) {
pan.setAttribute("label", tab.label)
tab = tab.nextSibling
pan = pan.nextSibling}
var mypanel = document.getElementById("calfo-panel")
pans.appendChild(mypanel.parentNode.removeChild(mypanel))
this.tabs.appendItem(mypanel.getAttribute("label"))
mypanel = document.getElementById("calfo-clock-panel")
this.clock = mypanel.firstChild
pans.appendChild(mypanel.parentNode.removeChild(mypanel))
var f = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("PrefD", Components.interfaces.nsIFile)
f.append("calfolder.rdf")
if (!f.exists()) this.setup(f)
var uri = Components.classes["@mozilla.org/network/protocol;1?name=file"].createInstance(Components.interfaces.nsIFileProtocolHandler).newFileURI(f)
this.data = document.getElementById("calfo-children").data
this.data.init(uri)
var fs = CalFolder.data.seq(CalFolder.data.root).GetElements()
while (fs.hasMoreElements()) {
var f = fs.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
this.folders[f.Value] = new this.folder(f)}
this.composite.init()
this.current.init()
this.tree.datasources = uri.spec
this.version = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).datasource.GetTarget(
this.data.RDF.GetResource("urn:mozilla:item:" + this.uuid),this.data.RDF.GetResource("http://www.mozilla.org/2004/em-rdf#version"),true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value
if (this.pref.version != this.version) {
this.pref.version = this.version
setTimeout(function () {CalFolder.prompt.about()}, 0)}
this.pref.apply()
this.tabs.parentNode.selectedIndex = tabIndex
addEventListener(
"click",function (event) {CalFolder.context.click(event)},true)
addEventListener(
"unload",function () {CalFolder.cleanup()},false)
getCalendarManager().addObserver(this)
getDisplayComposite().addObserver(this)
this.current.refresh()},setup: function (f) {
var UTF8 = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].getService(Components.interfaces.nsIScriptableUnicodeConverter)
UTF8.charset = "UTF-8"
try {
f.create(0, 420)
var s = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream)
s.init(f, 0x24, 292, null)
var head = '<?xml version="1.0"?>'
+ '\n<!DOCTYPE RDF:RDF>'
+ '\n<RDF:RDF'
+ '\n\txmlns:CF="http://calendarhelp.mozdev.org/calfo#"'
+ '\n\txmlns:NC="http://home.netscape.com/NC-rdf#"'
+ '\n\txmlns:RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#">'
var all = '\n<RDF:Seq RDF:about="urn:calfo:all"'
+ ' CF:name="' + this.tree.getAttribute("alllabel") + '" CF:type="all">'
var def = '\n<RDF:Seq RDF:about="urn:calfo:set:default"'
+ ' CF:name="' + this.tree.getAttribute("defaultlabel") + '" CF:type="set">'
var mgr = getCalendarManager()
var active = getDisplayComposite()
var defcal = active.defaultCalendar
var cals = mgr.getCalendars({})
var n = 0
for each (var cal in cals) {
all += '\n\t<RDF:li><RDF:Description'
+ ' RDF:about="#setup' + n + '"'
+ ' CF:name="' + UTF8.ConvertFromUnicode(cal.name) + '"'
+ ' CF:type="cal"'
+ ' CF:uri="' + cal.uri.spec + '"'
+ (cal == defcal ? ' CF:mark="on"' : '')
var clr = mgr.getCalendarPref(cal, "color") || this.defaultColor
clr = clr.replace(/^#/, "").toLowerCase()
this.color.reg(clr)
all += ' CF:color="s' + clr + '"'
var uri = cal.uri
if (uri && uri.spec.indexOf("moz-") != 0) all += ' CF:remote="url"'
all += '/></RDF:li>'
if (active.getCalendar(uri)) {
def += '\n\t<RDF:li><RDF:Description'
+ ' RDF:about="#def' + n + '"'
+ ' CF:name="' + cal.name + '"'
+ ' CF:type="cal"'
+ ' CF:uri="' + cal.uri.spec + '"'
+ (cal == defcal ? ' CF:mark="on"' : '')
+ ' CF:color="s' + clr + '"'
+ '/></RDF:li>'}
++n}
all += '\n</RDF:Seq>'
def += '\n</RDF:Seq>'
var root = '\n<RDF:Seq RDF:about="urn:calfo:root">'
+ '\n\t<RDF:li><RDF:Description RDF:about="urn:calfo:all"/></RDF:li>'
+ (n > 0 ?
'\n\t<RDF:li><RDF:Description RDF:about="urn:calfo:set:default"/></RDF:li>' :
'')
+ '\n</RDF:Seq>'
var tail = '\n</RDF:RDF>'
s.write(head, head.length)
s.write(all, all.length)
s.write(def, def.length)
s.write(root, root.length)
s.write(tail, tail.length)
s.close()}
catch (ex) {
alert("Calendar Folders can't create data file \n" + ex)}},need_cleanup: false,file_cleanup: [],cleanup: function () {
getCalendarManager().removeObserver(this)
getDisplayComposite().removeObserver(this)
for each (var f in this.file_cleanup) {
try {f.remove(false)} catch (ex) {}}
if (this.need_cleanup) this.tabs.selectedIndex = 0},drag: {
ctb: null,gesture: null,over: null,drop: null,init: function () {
this.ctb = document.getElementById("calendar-top-box")},fix: function (fix) {
with (this.ctb) {
if (fix) {
var gn = getAttributeNode("ondraggesture")
if (gn) {
this.gesture = removeAttributeNode(gn)
this.over = removeAttributeNode(getAttributeNode("ondragover"))
this.drop = removeAttributeNode(getAttributeNode("ondragdrop"))}}
else {
if (this.gesture) {
setAttributeNode(this.gesture)
setAttributeNode(this.over)
setAttributeNode(this.drop)}}}}},color: {
colors: {},sheet: null,popup: null,picker: null,data: null,tree: null,gray: NaN,init: function () {
for each (var s in document.styleSheets) {
if (s.href == "chrome://calfolder/content/calfolder.css") {
this.sheet = s
break}}
var mgr = getCalendarManager()
var cals = mgr.getCalendars({})
for each (var cal in cals) {
var clr = mgr.getCalendarPref(cal, "color") || "f9f4ff"
if (clr) {
clr = clr.replace(/^#/, "").toLowerCase()
this.reg(clr)}}
this.popup = document.getElementById("calfo-colorpopup")
this.picker = document.getElementById("calfo-colorpicker")
this.data = CalFolder.data
this.tree = CalFolder.tree
this.gray = CalFolder.pref.gray
if (this.gray < 0 || this.gray > 255) {
this.gray = window.navigator.platform.toLowerCase().indexOf("mac") >= 0 ? 95 : 136
CalFolder.pref.gray = this.gray}
window.getContrastingTextColor = this.contrast},change: function (x, y, res) {
this.popup.calfores = res
x += this.tree.boxObject.x - (CalFolder.pref.palette ? 15 : 2)
y += this.tree.boxObject.y + 2
var c = this.data.getColor(res) || "f9f4ff"
setTimeout(
function () {CalFolder.color.change2(x, y, c)},0)},change2: function (x, y, c) {
document.popupNode = CalFolder.body
this.popup.showPopup(document.documentElement, x, y, 'popup', null, null)
this.picker.initColor("#" + c)
this.picker.infocus = true},contrast: function (c) {
var r = /([0-9A-f]{2})([0-9A-f]{2})([0-9A-f]{2})/i(c)
return (.3 * parseInt(r[1], 16) + .6 * parseInt(r[2], 16) + .1 * parseInt(r[3], 16)
> CalFolder.color.gray)? "black" : "white"},pick: function () {
var res = this.popup.calfores
if (!res) return
var c = this.picker.color.replace(/^#/, "").toLowerCase()
if (CalFolder.pref.color) {
this.data.setColor(this.data.allRes(res), c)
this.data.lock(false, true)}
else this.data.setColor(res, c)
this.popup.hidePopup()
this.picker.infocus = false
this.reg(c)
CalFolder.current.refresh()
this.data.write()
this.popup.calfores = null},reg: function (clr) {
if (!clr || this.colors[clr]) return
with (this.sheet) insertRule(
'#calfo-tree treechildren::'
+ '-moz-tree-cell-text(color,s' + clr + ') '
+ '{color:#' + clr + ';'
+ ' background-color:#' + clr + ';'
+ ' border:1px dotted #444;}',cssRules.length)
this.colors[clr] = true}},rename: {
textbox: null,active: false,res: null,row: null,tree: null,body: null,data:null,scrollbar: null,init: function () {
this.textbox = document.getElementById("calfo-textbox")
this.tree = CalFolder.tree
this.body = CalFolder.body
this.data = CalFolder.data
addEventListener(
"DOMMouseScroll",function (event) {
var id = event.target.parentNode.id
if ((id == "calfo-tree" || id == "calfo-panel")
&& !CalFolder.rename.scrollbar.collapsed)
CalFolder.rename.exit(false)},false)},exit: function (ok) {
if (ok == null && !this.active) return
if (ok) {
var v = this.textbox.value.replace(/^\s+|\s+$/g, "")
if (v) {
if (CalFolder.pref.name && this.data.getType(this.res) == "cal") {
this.data.setName(this.data.allRes(this.res), v)
this.data.lock(true, false)}
else this.data.setName(this.res, v)}
this.data.write()}
this.textbox.setAttribute("hidden", "true")
this.active = false},focus: function () {
this.textbox.focus()
setTimeout("CalFolder.rename.active = true", 0)},key: function (event) {
switch (event.keyCode) {
case 9:
case 13:
this.exit(true)
break
case 27:
this.exit(false)
break}},popup: function (res, row) {
this.res = res, this.row = row
var box = CalFolder.tree.boxObject
var x = {}, y = {}
box.getCoordsForCellItem(row, box.columns.getNamedColumn("calfo-name"), "text", x, y, {}, {})
var w = this.tree.boxObject.width - x.value - 8
x = x.value + this.tree.boxObject.x - 2
y = y.value + this.tree.boxObject.y - 2
var tr = document.getAnonymousElementByAttribute(this.tree, "class", "tree-rows")
this.scrollbar = document.getAnonymousElementByAttribute(tr, "class", "tree-scrollbar")
if (this.scrollbar && !this.scrollbar.collapsed) w -= this.scrollbar.boxObject.width
with (this.textbox) {
with (style) left = x + "px", top = y + "px", width = w + "px"
value = this.data.getName(res)
removeAttribute("hidden")
select()}
this.body.clearSelection()
setTimeout("CalFolder.rename.focus()", 0)}},context: {
menu: null,tree: null,data: null,current: null,row: null,res: null,clientX: 0,clientY: 0,init: function () {
this.menu = document.getElementById("calfo-context")
this.menu_properties = document.getElementById("calfo-properties")
this.menu_change = document.getElementById("calfo-change")
this.menu_report = document.getElementById("calfo-report")
this.menu_default = document.getElementById("calfo-default")
this.menu_select = document.getElementById("calfo-select")
this.menu_rename = document.getElementById("calfo-rename")
this.menu_recolor = document.getElementById("calfo-recolor")
this.menu_reload = document.getElementById("calfo-reload")
this.menu_delete = document.getElementById("calfo-delete")
this.tree = CalFolder.tree
this.data = CalFolder.data
this.current = CalFolder.current},click: function (event) {
if (event.button == 2
&& event.target.localName == "treechildren"
&& event.target.parentNode.id == "calfo-tree") {
this.clientX = event.clientX
this.clientY = event.clientY}},key: function (event) {
if (event.target.id == "calfo-tree") switch (event.keyCode) {
case event.DOM_VK_CONTEXT_MENU:
this.clientX = 0
this.clientY = 0
this.bug = true
break
case event.DOM_VK_F10:
if (event.shiftKey) {
this.clientX = 0
this.clientY = 0
this.bug = true}
break
case event.DOM_VK_DELETE:
var row = this.tree.currentIndex
if (row < 0) return
var res = this.data.res(row)
var typ = this.data.getType(res)
if (typ == "all") return
this.remove(res, row)
break
case 0:
if (event.charCode == 32) {
var row = this.tree.currentIndex
if (row < 0) return
var res = this.data.res(row)
if (this.data.getType(res) == "cal") this.makeDefault(res, row)
else this.select(res, row)}
break}},change: function (res, row) {
if (!res) res = this.res, row = this.row
CalFolder.prompt.change(res, row)
this.res = null, this.row = null},makeDefault: function (res, row) {
if (!res) res = this.res, row = this.row
if (this.data.getType(res) == "cal" && !this.data.getMark(res))
this.data.setDefaultMark(res, this.data.seq(this.data.parentRes(row)))
this.res = null, this.row = null
this.data.write()},newFolder: function (res, row) {
var f = this.data.newSet(this.tree.getAttribute("newlabel"))
var ix = this.tree.builder.getIndexOfResource(f)
this.tree.treeBoxObject.ensureRowIsVisible(ix)
CalFolder.rename.popup(f, ix)
this.data.write()
CalFolder.folders[f.Value] = new CalFolder.folder(f)},publish: function (res, row) {
CalFolder.prompt.test()},properties: function (res, row) {
var row = this.tree.currentIndex
var res = this.data.res(row)
CalFolder.prompt.properties(res, row)
this.res = null, this.row = null},recolor: function (res, row) {
if (!res) res = this.res, row = this.row
var box = CalFolder.tree.boxObject
var x = {}, y = {}, h = {}
box.getCoordsForCellItem(row, box.columns.getNamedColumn("calfo-color"), "text", x, y, {}, h)
CalFolder.color.change(x.value, y.value + h.value, res)
this.res = null, this.row = null},reload: function (res, row) {
if (this.res) {
this.data.reload(this.res)
this.res = null, this.row = null}},remove: function (res, row) {
if (!res) res = this.res, row = this.row
var iscal = (this.data.getType(res) == "cal")
if (iscal) {
var par = this.data.parentRes(row)
if (this.data.getType(par) == "set") {
this.data.remove(res, this.data.seq(par))
return}}
var ok = CalFolder.prompt.confirmDelete(this.data.getName(res), iscal)
if (ok) {
if (iscal) {
var cal = this.data.cal(res)
var spec = cal.uri.spec
var enf = this.data.seq(this.data.root).GetElements()
while (enf.hasMoreElements()) {
var f = this.data.seq(enf.getNext().QueryInterface(Components.interfaces.nsIRDFResource))
var enc = f.GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.data.getURI(c) == spec) this.data.remove(c, f)}}
with (this.data.mgr) {
unregisterCalendar(cal)
this.data.mgr.deleteCalendar(cal)}}
else {
var seq = this.data.seq(res)
var enc = seq.GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
this.data.remove(c, seq)}
this.data.remove(res, this.data.seq(this.data.root))
delete CalFolder.folders[res.Value]}}
this.data.write()
this.res = null, this.row = null},rename: function (res, row) {
if (!res) res = this.res, row = this.row
CalFolder.rename.popup(res, row)
this.res = null, this.row = null},report: function (res, row) {
if (!res) res = this.res, row = this.row
CalFolder.prompt.report(res, row)
this.res = null, this.row = null},select: function (res, row) {
if (!res) res = this.res
if (this.data.getMark(res)) this.data.clearMark(res)
else if (this.data.getType(res) == "all") {
this.data.clearChecks()
this.data.setMark(res)}
else if (CalFolder.pref.single) {
this.data.clearChecks()
this.data.setMark(res)}
else {
this.data.clearMark(this.data.all)
this.data.setMark(res)}
setCursor("wait")
setTimeout(function () {CalFolder.context.selectNow(res)}, 0)},selectNow: function (res) {
switch (this.data.getType(res)) {
case "all":
if (this.data.getMark(res)) this.current.folder(res, true)
else this.current.clear()
break
case "set":
if (this.data.getMark(res)) {
this.current.folder(this.data.all, false)
this.current.folder(res, true)}
else {
this.current.folder(res, false)}
break}
this.res = null, this.row = null
this.data.write()
this.current.refresh()
setCursor("default")},showing: function (event) {
var x = event.clientX || this.clientX
var y = event.clientY || this.clientY
if (x == 0 && y == 0) {
var ix = this.tree.currentIndex
if (ix < 0) return
var ax = {}, ay = {}, ah = {}
with (this.tree.treeBoxObject)
getCoordsForCellItem(ix, columns.getPrimaryColumn(), "text", ax, ay, {}, ah)
x = ax.value + this.tree.boxObject.x
y = ay.value + this.tree.boxObject.y
this.clientX = x
this.clientY = y
var mytree = this.tree
setTimeout(
function () {
event.target.showPopup(mytree, x + 24, y + 4, "context")},0)
return false}
else {
var row = {}, col = {}, child = {}
this.tree.treeBoxObject.getCellAt(x, y, row, col, child)
var ix = row.value}
this.row = ix
if (ix >= 0) {
var m = this.menu.firstChild
while (m) m.removeAttribute("hidden"), m = m.nextSibling
var res = this.data.res(ix)
var typ = this.data.getType(res)
if (typ == "cal") {
this.menu_report.setAttribute("hidden", "true")
this.menu_change.setAttribute("hidden", "true")
this.menu_select.setAttribute("hidden", "true")
if (this.data.getMark(res)) this.menu_default.setAttribute("checked", "true")
else this.menu_default.removeAttribute("checked")
if (!this.data.getRemote(res)) this.menu_reload.setAttribute("hidden", "true")}
else {
if (this.data.getMark(res)) this.menu_select.setAttribute("checked", "true")
else this.menu_select.removeAttribute("checked")
this.menu_default.setAttribute("hidden", "true")
this.menu_recolor.setAttribute("hidden", "true")
if (typ == "all") {
this.menu_delete.setAttribute("hidden", "true")}}}
else {
var m = this.menu.lastChild
while (m.localName != "menuseparator") m = m.previousSibling
while (m) m.setAttribute("hidden", "true"), m = m.previousSibling}
this.res = res}},prompt: {
ps: null,ww: null,init: function () {
this.ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService)
this.ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher)},about: function () {
var box = CalFolder.tabs.lastChild.boxObject
var xpos = box.screenX
var ypos = box.screenY + box.height
this.ww.openWindow(
self,"chrome://calfolder/content/about.xul","calfolder:about","chrome,resizable=no,dialog,screenx=" + xpos + ", screeny=" + ypos,null)},change: function (res, row) {
var box = CalFolder.tree.boxObject
var xpos = box.screenX + box.width - 10
var ypos = box.screenY + 10
this.ww.openWindow(
self,"chrome://calfolder/content/change.xul","calfolder:change","chrome,modal,dialog,resizable=yes,screenx=" + xpos + ", screeny=" + ypos,res)},confirmDelete: function (name, iscal) {
var dat = document.getElementById(iscal ? "calfo-delcal" : "calfo-delset")
var v = {}
return this.ps.confirm(self,dat.getAttribute("title"),dat.getAttribute("text").replace(/\%/, name))},error: function (title, msg) {
this.ps.alert(self, title, msg)},properties: function (res, row) {
var box = CalFolder.tree.boxObject
var xpos = box.screenX + box.width - 10
var ypos = box.screenY + 10
this.ww.openWindow(
self,"chrome://calfolder/content/properties.xul","calfolder:properties","chrome,modal,dialog,resizable=yes,screenx=" + xpos + ", screeny=" + ypos,res)},report: function (res, row) {
var box = CalFolder.tree.boxObject
var xpos = box.screenX + box.width - 10
var ypos = box.screenY + 10
this.ww.openWindow(
self,"chrome://calfolder/content/report.xul","calfolder:change","chrome,modal,dialog,resizable=yes,centerscreen",res)},view: function (f) {
var u = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(f)
Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService).loadUrl(u)},test: function () {
this.ww.openWindow(
self,"chrome://calfolder/content/test.xul","calfolder:test","chrome,resizable,titlebar=no,centerscreen",null)}},pref: {
branch: null,init: function () {
this.branch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("calfolder.")},apply: function () {
var tabs = CalFolder.tabs
var pans = tabs.nextSibling
var p = tabs.parentNode.selectedPanel
var lblwas = p ? p.getAttribute("label") : ""
var pan = document.getElementById("calfo-clock-panel")
var ck = document.getElementById("clock")
var got = !ck.getAttribute("hidden")
var need = this.clock
if (need && !got) {
with (pans) insertBefore(removeChild(pan), firstChild)
pan.removeAttribute("hidden")
setTimeout(function () {document.getElementById("clock").start()}, 200)}
else if (got && !need) {
ck.stop()
pan.setAttribute("hidden", "true")
with (tabs) if (selectedIndex == 0) selectedIndex = 1
with (pans) appendChild(removeChild(firstChild))}
pan = document.getElementById("list-calendars-listbox").parentNode
got = !pan.getAttribute("hidden")
need = this.list
var ix = ck.getAttribute("hidden") ? 1 : 2
if (need && !got) {
with (pans) insertBefore(removeChild(pan), document.getElementById("calfo-panel"))
pan.removeAttribute("hidden")}
else if (got && !need) {
pan.setAttribute("hidden", "true")
with (pans) appendChild(removeChild(pan))}
var tab = tabs.firstChild
while (tab) {
tab.removeAttribute("first-tab")
tab.removeAttribute("last-tab")
tab = tab.nextSibling}
tabs.firstChild.setAttribute("first-tab", "true")
tabs.lastChild.setAttribute("last-tab", "true")
var ix = 0
for (var i = 0, tab = tabs.firstChild, pan = pans.firstChild;
pan;
++i, pan = pan.nextSibling) {
var ntab = tab ? tab.nextSibling : null
if (pan.hasAttribute("hidden")) {
if (tab) tabs.removeItemAt(i--)}
else {
var l = pan.getAttribute("label")
if (tab) tab.label = l
else {
tab = tabs.appendItem(l)
if (pan.id) tab.id = pan.id + "-tab"}
if (l == lblwas) ix = i}
tab = ntab}
tabs.parentNode.selectedIndex = ix
with (CalFolder.clock) {
dateformat = this.dateformat
datelong = this.datelong
dateordinal = this.dateordinal
dateweek = this.dateweek
timeformat = this.timeformat
refresh()}
var ln = this.name, lc = this.color
if (ln || lc) CalFolder.data.lock(ln, lc)
document.getElementById("calfo-colorpicker").setAttribute("palettename", this.palette ? "calfolder" : "standard")},get clock () {return this._value("display.clock", false)},set clock (v) {this.branch.setBoolPref("display.clock", v)},get dateformat () {return this._value("date.format", 0)},set dateformat (v) {this.branch.setIntPref("date.format", v)},get datelong () {return this._value("date.long", false)},set datelong (v) {this.branch.setBoolPref("date.long", v)},get dateordinal () {return this._value("date.ordinal", false)},set dateordinal (v) {this.branch.setBoolPref("date.ordinal", v)},get dateweek () {return this._value("date.week", false)},set dateweek (v) {this.branch.setBoolPref("date.week", v)},get gray () {return this._value("gray", -1)},set gray (v) {this.branch.setIntPref("gray", v)},get list () {return this._value("display.list", false)},set list (v) {this.branch.setBoolPref("display.list", v)},get color () {return this._value("lock.color", false)},set color (v) {this.branch.setBoolPref("lock.color", v)},get name () {return this._value("lock.name", false)},set name (v) {this.branch.setBoolPref("lock.name", v)},get palette () {return this._value("palette", false)},set palette (v) {this.branch.setBoolPref("palette", v)},get single () {return this._value("single", false)},set single (v) {this.branch.setBoolPref("single", v)},get timeformat () {return this._value("time.format", 0)},set timeformat (v) {this.branch.setIntPref("time.format", v)},get version () {return this._value("version", null)},set version (v) {this.branch.setCharPref("version", v)},_value: function (name, def) {
var t = null
try {t = this.branch.getPrefType(name)} catch (e) {}
if (!t) return def
try {
switch (t) {
case 32: return this.branch.getCharPref(name)
case 64: return this.branch.getIntPref(name)
case 128: return this.branch.getBoolPref(name)
default: return def}}
catch (e) {return def}}},current: {
data: null,now: null,seq: null,list: null,show: {},def: null,init: function () {
this.data = CalFolder.data
this.now = this.data.now
this.seq = this.data.seq(this.now)
this.list = document.getElementById("list-calendars-listbox")},clear: function () {
var enum = this.seq.GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
this.seq.RemoveElement(e, false)}
this.setDefault(null, true)
this.refresh()},folder: function (res, add) {
var enum = this.data.seq(res).GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var has = (this.seq.IndexOf(e) >= 0)
if (add && !has) {
this.seq.AppendElement(e)
if (this.data.getMark(e)) this.setDefault(e, false)}
else if (!add && has) {
this.seq.RemoveElement(e, true)}}
CalFolder.folders[res.Value].rebuild()
this.refresh()},_once: false,refresh: function () {
if (this._once) return
setTimeout(function () {CalFolder.current.refreshOnce()}, 0)
this._once = true},refreshOnce: function () {
var mgr = this.data.mgr
this.show = {}
this.def = null
this._once = false
var cals = mgr.getCalendars({})
for each (var cal in cals) this.show[cal.uri.spec] = cal.uri
CalFolder.inhibit = true
var enum = this.data.seq(this.data.root).GetElements()
_dump("refreshOnce \n")
while (enum.hasMoreElements()) {
var f = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var ok = this.data.getMark(f)
CalFolder.composite.folder(f, ok)
if (ok) {
var cals = this.data.seq(f).GetElements()
while (cals.hasMoreElements()) {
var e = cals.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var cal = this.data.cal(e)
if (!cal) dump("current refresh no cal for " + this.data.getURI(e) + "\n")
var s = cal.uri.spec
if (!this.show[s].name) {
this.show[s] = cal
if (!this.def && this.data.getMark(e)) this.def = cal
var c = this.data.getColor(e)
var clr = mgr.getCalendarPref(cal, 'color') || "f9f4ff"
if (c && c != clr.replace(/^#/, "").toLowerCase())
mgr.setCalendarPref(cal, 'color', "#" + c.toUpperCase())
var n = this.data.getName(e)
if (n != cal.name) cal.name = n}}}}
CalFolder.inhibit = false
var act = this.data.act
for (var s in this.show) {
var cal = this.show[s]
if (cal.name) try {act.addCalendar(cal)} catch (ex) {}
else try {act.removeCalendar(cal)} catch (ex) {}}
if (this.def) {
act.defaultCalendar = this.def
var s = this.def.uri.spec
var it = this.list.firstChild.nextSibling
while (it) {
if (it.calendar.uri.spec == s) {
this.list.selectItem(it)
break}
it = it.nextSibling}}
refreshEventTreeInternal([])
refreshEventTree()
refreshToDoTree([])
toDoUnifinderRefresh()},setDefault: function (res, force) {
var d = this.data.getDefault(this.now)
if (d && !force) return
if (d) this.data.clearDefault(this.now)
if (res) this.data.setDefault(this.now, res.Value)}},QueryInterface: function(id) {
if (id.equals(Components.interfaces.nsISupports)
|| id.equals(Components.interfaces.calICalendarManagerObserver)
|| id.equals(Components.interfaces.calIObserver)
|| id.equals(Components.interfaces.calICompositeObserver))
return this
throw Components.results.NS_ERROR_NO_INTERFACE},onCalendarRegistered: function(cal) {
this.data.insert(
this.data.seq(this.data.all),this.data.newCal(cal),Infinity,false)},onCalendarUnregistering: function(cal) {
dump("onCalendarUnregistering \n")},onCalendarDeleting: function(cal) {},onCalendarPrefSet: function(cal, name, value) {
if (this.inhibit) return
if (name == "name") {
this.data.setName(this.data.allRes(cal.uri.spec), value)
this.data.write()}
if (name == "color") {
this.data.setColor(this.data.allRes(cal.uri.spec), value.replace(/^#/, "").toLowerCase())
this.data.write()}},onCalendarPrefDeleting: function(cal, name) {},onCalendarAdded: function (cal) {if (!CalFolder.inhibit) CalFolder.composite.calendar(cal, true)},onCalendarRemoved: function (cal) {if (!CalFolder.inhibit) CalFolder.composite.calendar(cal, false)},onDefaultCalendarChanged: function (cal) {},onStartBatch: function() {},onEndBatch: function() {},onLoad: function() {},onAddItem: function() {},onModifyItem: function() {},onDeleteItem: function() {},onAlarm: function() {},onError: function() {},data: {
RDF: null,CU: null,mgr: null,act: null,colorProp: null,defaultProp: null,filterProp: null,markProp: null,nameProp: null,remoteProp: null,reportProp: null,typeProp: null,uriProp: null,propertyProp: null,modeProp: null,valueProp: null,onLiteral: null,urlLiteral: null,netLiteral: null,tree: null,body: null,ds: null,root: null,all: null,now: null,init: function (uri) {
if (this.ds) return
this.RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService)
this.CU = Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils)
this.mgr = getCalendarManager()
this.act = getDisplayComposite()
this.ds = this.RDF.GetDataSourceBlocking(uri.spec)
const ns = "http://calendarhelp.mozdev.org/calfo#"
this.colorProp = this.RDF.GetResource(ns + "color")
this.defaultProp = this.RDF.GetResource(ns + "default")
this.filterProp = this.RDF.GetResource(ns + "filter")
this.modeProp = this.RDF.GetResource(ns + "mode")
this.nameProp = this.RDF.GetResource(ns + "name")
this.propertyProp = this.RDF.GetResource(ns + "property")
this.remoteProp = this.RDF.GetResource(ns + "remote")
this.reportProp = this.RDF.GetResource(ns + "report")
this.typeProp = this.RDF.GetResource(ns + "type")
this.markProp = this.RDF.GetResource(ns + "mark")
this.uriProp = this.RDF.GetResource(ns + "uri")
this.valueProp = this.RDF.GetResource(ns + "value")
this.onLiteral = this.RDF.GetLiteral("on")
this.urlLiteral = this.RDF.GetLiteral("url")
this.netLiteral = this.RDF.GetLiteral("net")
this.root = this.RDF.GetResource("urn:calfo:root")
this.all = this.RDF.GetResource("urn:calfo:all")
this.now = this.RDF.GetResource("urn:calfo:now")
this.tree = CalFolder.tree
this.body = CalFolder.body
var enf = this.seq(this.root).GetElements()
while (enf.hasMoreElements()) {
var f = enf.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var enc = this.seq(f).GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
CalFolder.color.reg(this.getColor(c))}}},allRes: function (res) {
var u = (typeof res == "string")? res : this.getURI(res)
var enc = this.seq(this.all).GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.getURI(c) == u) return c}},cal: function (res) {
var uri = this.getURI(res)
var cals = this.mgr.getCalendars({})
for each (var cal in cals) if (cal.uri.spec == uri) return cal},calColor: function (cal) {
return this.mgr.getCalendarPref(cal, 'color') || "f9f4ff"},clearChecks: function () {
var enum = this.ds.GetSources(this.markProp, this.onLiteral, true)
while (enum.hasMoreElements()) {
var res = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.getType(res) != "cal") this.clearMark(res)}},clearDefault: function (res) {
var d = this.ds.GetTarget(res, this.defaultProp, true)
if (d) this.ds.Unassert(res, this.defaultProp, d)},clearMark: function (res) {
var m = this.ds.GetTarget(res, this.markProp, true)
if (m) this.ds.Unassert(res, this.markProp, m)},container: function (res) {
return this.CU.IsContainer(this.ds, res)},getColor: function (res) {
var c = this.ds.GetTarget(res, this.colorProp, true)
if (!c) return null
return c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value.replace(/^s/, "")},getCriteria: function (res) {
var a = {}
var s = this.ds.GetTarget(res, this.filterProp, true)
if (!s) return a
var enum = this.seq(s).GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var p = this.ds.GetTarget(e, this.propertyProp, true)
if (p) p = p.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
var m = this.ds.GetTarget(e, this.modeProp, true)
if (m) m = m.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
var v = this.ds.GetTarget(e, this.valueProp, true)
if (v) v = v.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
if (p && m && v) a[p] = {mode: m, value: v}}
return a},getDefault: function (res) {
var d = this.ds.GetTarget(res, this.defaultProp, true)
return d ? d.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getFilter: function (res) {
var f = this.ds.GetTarget(res, this.filterProp, true)
return f ? this.seq(f.QueryInterface(Components.interfaces.nsIRDFResource)) : null},getMark: function (res) {
var m = this.ds.GetTarget(res, this.markProp, true)
return m ? m.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getName: function (res) {
return this.ds.GetTarget(res, this.nameProp, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value},getRemote: function (res) {
var r = this.ds.GetTarget(res, this.remoteProp, true)
return r ? r.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getReport: function (res) {
var r = this.ds.GetTarget(res, this.reportProp, true)
return r ? r.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getSet: function (res) {
var ena = this.ds.ArcLabelsIn(res)
while (ena.hasMoreElements()) {
var a = ena.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var ens = this.ds.GetSources(a, res, true)
while (ens.hasMoreElements()) {
var s = ens.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (s && s.Value != "urn:calfo:now") return s}}
return null},getType: function (res) {
var t = this.ds.GetTarget(res, this.typeProp, true)
return t ? t.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getURI: function (res) {
var u = this.ds.GetTarget(res, this.uriProp, true)
return u ? u.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},insert: function (seq, res, ix, replace) {
var a = []
var enum = seq.GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
a.push(e)}
for (var i = 0; i < a.length; ++i) seq.RemoveElement(a[i], true)
var iscal = (this.getType(res) == "cal")
var spec = iscal ? this.cal(res).uri.spec : res.Value
for (var i = 0; i < a.length; ++i) {
var e = a[i]
if (i == ix) {
seq.AppendElement(res)
res = null}
if ((iscal ? this.cal(e).uri.spec : e.Value) != spec) {
seq.AppendElement(e)}
else {
if (replace) this.remove(e)}}
if (res) seq.AppendElement(res.Resource ? res.Resource : res)},lock: function (doname, docolor) {
var enf = this.seq(this.root).GetElements()
while (enf.hasMoreElements()) {
var f = enf.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var all = (f.Value == "urn:calfo:all")
var enc = this.seq(f).GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var cal = this.cal(c)
if (all) {
if (doname) {
CalFolder.inhibit = true
var cn = this.getName(c)
if (cal.name != cn) cal.name = cn
CalFolder.inhibit = false}
if (docolor) {
CalFolder.inhibit = true
var cc = this.getColor(c)
if (cc && this.mgr.getCalendarPref(cal, 'color').replace(/^#/, "").toLowerCase() != cc)
this.mgr.setCalendarPref(cal, 'color', "#" + cc.toUpperCase())
CalFolder.inhibit = false}}
else {
if (doname) {
var cn = cal.name
if (this.getName(c) != cn) this.setName(c, cn)}
if (docolor) {
var cc = this.mgr.getCalendarPref(cal, 'color').replace(/^#/, "").toLowerCase()
if (cc && this.getColor(c) != cc) this.setColor(c, cc)}}}}},newCal: function (cal) {
var res = this.RDF.GetAnonymousResource()
this.setType(res, "cal")
this.setName(res, cal.name)
var u = cal.uri.spec
this.setURI(res, u)
if (u.indexOf("moz-") != 0) this.setRemote(res, false)
this.setColor(res, this.mgr.getCalendarPref(cal, 'color') || "f9f4ff")
return res},newSet: function (name) {
var res = this.RDF.GetAnonymousResource()
this.setType(res, "set")
this.setName(res, name)
this.insert(this.seq(this.root), res, 1, false)
return res},parentRes: function (row) {
var p = this.tree.treeBoxObject.view.getParentIndex(row)
return p >= 0 ? this.tree.view.getResourceAtIndex(p) : this.root},reload: function (res) {
var cal = this.cal(res)
this.setRemote(res, true)
cal.uri = cal.uri
setTimeout(
function (res) {CalFolder.data.setRemote(res, false)},1100,res)},remove: function (res, seq) {
var enum = this.ds.ArcLabelsOut(res)
while (enum.hasMoreElements()) {
var p = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var t = this.ds.GetTarget(res, p, true)
if (t) this.ds.Unassert(res, p, t, true)}
if (!seq) return
var a = []
var enum = seq.GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
a.push(e)}
for (var i = 0; i < a.length; ++i) seq.RemoveElement(a[i], true)
for (var i = 0; i < a.length; ++i) {
var e = a[i]
if (e.Value != res.Value) seq.AppendElement(e)}},res: function (row) {
return this.tree.view.getResourceAtIndex(row)},seq: function (ctr) {
return this.CU.MakeSeq(this.ds, ctr)},setColor: function (res, clr) {
if (!clr || !res) return
var cl = clr.replace(/^#/, "").toLowerCase()
var t = this.ds.GetTarget(res, this.colorProp, true)
if (t) this.ds.Unassert(res, this.colorProp, t)
this.ds.Assert(res,this.colorProp,this.RDF.GetLiteral("s" + cl),true)
CalFolder.color.reg(cl)},setCriterion: function (res, prop, mode, value) {
var s = this.ds.GetTarget(res, this.filterProp, true)
if (!s) {
s = this.RDF.GetAnonymousResource()
this.ds.Assert(res, this.filterProp, s, true)}
s = this.seq(s)
var p = this.RDF.GetLiteral(prop)
var enum = s.GetElements(), crit = null
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.ds.HasAssertion(e, this.propertyProp, p, true)) {
crit = e
break}}
if (!mode || !value) {
if (crit) s.RemoveElement(crit, true)
return}
if (!crit) {
crit = this.RDF.GetAnonymousResource()
this.ds.Assert(crit, this.propertyProp, p, true)
s.AppendElement(crit)}
var t = this.ds.GetTarget(crit, this.modeProp, true)
if (t) this.ds.Unassert(crit, this.modeProp, t)
this.ds.Assert(crit, this.modeProp, this.RDF.GetLiteral(mode), true)
var t = this.ds.GetTarget(crit, this.valueProp, true)
if (t) this.ds.Unassert(crit, this.valueProp, t)
this.ds.Assert(crit, this.valueProp, this.RDF.GetLiteral(value), true)},setDefault: function (res, v) {
this.ds.Assert(res, this.defaultProp, this.RDF.GetLiteral(v), true)},setDefaultMark: function (res, seq) {
var enum = seq.GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
this.clearMark(e)}
this.setMark(res)},setMark: function (res) {
this.ds.Assert(res, this.markProp, this.onLiteral, true)},setName: function (res, n) {
var p = this.ds.GetTarget(res, this.nameProp, true)
if (p) this.ds.Unassert(res, this.nameProp, p)
if (n) this.ds.Assert(res, this.nameProp, this.RDF.GetLiteral(n), true)},setRemote: function (res, net) {
this.ds.Assert(
res,this.remoteProp,(net ? this.netLiteral : this.urlLiteral),true)},setReport: function (res, s) {
var t = this.ds.GetTarget(res, this.reportProp, true)
if (t) this.ds.Unassert(res, this.reportProp, t)
if (s) this.ds.Assert(res, this.reportProp, this.RDF.GetLiteral(s), true)},setType: function (res, t) {
this.ds.Assert(res, this.typeProp, this.RDF.GetLiteral(t), true)},setURI: function (res, u) {
this.ds.Assert(res, this.uriProp, this.RDF.GetLiteral(u), true)},uriRes: function (uri) {
return this.ds.GetSource(this.uriProp, this.RDF.GetLiteral(uri.spec), true)},write: function () {
this.ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush()}},entry: function (item) {
this.calItem = item},entry_prototype: {
getProperty: function (p) {
switch (p) {
case "DT_END":
var r = this.calItem.getProperty("COMPLETED")
if (r) return r
r = this.calItem.getProperty("DUE")
if (r) return r
return this.calItem.getProperty("DTEND")
case "TYPE":
return this.calItem.icalComponent.componentType.substr(1)
default:
return this.calItem.getProperty(p)}}},sandbox: {
_window: null,_context: {item: null},errorTitle: "",init: function () {
var f = document.getElementById("calfo-sandbox")
this.errorTitle = f.getAttribute("errortitle")
this._window = f.contentWindow
with (this._window) {
alert = undefined
prompt = undefined}
this._window.Entry = function () {}
var ctx = this._context
this._window.Entry.prototype = {
get alarm () {return ctx.item.alarmTime},get attachments () {return ctx.item.attachments},get attendees () {return ctx.item.attendees},get category () {return ctx.item.getProperty("CATEGORIES")},get class () {return ctx.item.getProperty("CLASS")},get completed () {return ctx.item.getProperty("COMPLETED")},get created () {return ctx.item.creationDate},get description () {return ctx.item.getProperty("DESCRIPTION")},get due () {return ctx.item.getProperty("DUE")},get end () {return ctx.item.getProperty("DTEND")},get generation () {return ctx.item.generation},get id () {return ctx.item.id},get location () {return ctx.item.getProperty("LOCATION")},get modified () {return ctx.item.getProperty("LAST-MODIFIED")},get organizer () {return ctx.item.organizer},get priority () {return ctx.item.priority},get progress () {return 100},get recurrence () {return {id: ctx.item.recurrenceId, info: ctx.item.recurrenceInfo}},get stamp () {return ctx.item.getProperty("DTSTAMP")},get start () {return ctx.item.getProperty("DTSTART")},get status () {return ctx.item.status},get title () {return ctx.item.title},get type () {return ctx.item.icalComponent.componentType},get url () {return ctx.item.getProperty("URL")}}},run: function (filter, entry, live) {
var ctx = this._context
ctx.item = entry
var o = new this._window.Object
o.eval = o.__proto__.eval
o.__proto__ = this._window.Entry.prototype
o.eval.__proto__ = null
try {
o.eval('_pass = ' + filter.script, o)}
catch (ex) {
if (live) CalFolder.prompt.error(this.errorTitle, ex)
else filter.error = ex
filter.script = 'false'}
return this._window._pass}},folder: function (res) {
this.res = res
this.seq = CalFolder.data.seq(res)
this.count = this.seq.GetCount()
this.rebuild()},folder_prototype: {
res: null,seq: null,count: NaN,filter: null,get name () {return CalFolder.data.getName(this.res)},_pending: NaN,entries: NaN,_caller: null,getItems: function (pf, pn, ps, pe, caller) {
this.prepare(caller || CalFolder.composite)
var cals = this.seq.GetElements()
while (cals.hasMoreElements()) {
var e = cals.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var cal = CalFolder.data.cal(e)
if (!cal) dump("composite getItems no cal for " + CalFolder.data.getURI(e) + "\n")
cal.getItems(pf, pn, ps, pe, this)}},prepare: function (caller) {
this._pending = this.count
this.entries = 0
this._caller = caller},rebuild: function () {
this.filter = []
var ca = CalFolder.data.getCriteria(this.res)
for (var p in ca) {
var c = ca[p]
var v = c.value
switch (parseInt(c.mode)) {
case 1: 
var ws = v.split(" ")
this.filter.push({property: p, filter: new RegExp(ws.join("|"), "i")})
break
case 2: 
var ws = v.split(" ")
for each (var w in ws) this.filter.push({property: p, filter: new RegExp(w, "i")})
break
case 3: 
this.filter.push({property: p, filter: new RegExp(v, "i")})
break
case 4: 
this.filter.push({property: p, filter: new RegExp(c.value, "i")})
break
case 5: 
this.filter.push({property: p, filter: new RegExp(c.value, "i")})
break
case 6: 
this.filter.push({property: "DT" + p.replace(/_bis/, ""), filter: {
date: c.value,test: function (v) {
if (!v) return false
return v.toString().match(/([^ ]+)\s/)[1].replace(/[\/]/g, "") < this.date}}})
break
case 7: 
this.filter.push({property: "DT" + p.replace(/_bis/, ""), filter: {
date: c.value,test: function (v) {
if (!v) return false
return v.toString().match(/([^ ]+)\s/)[1].replace(/[\/]/g, "") > this.date}}})
break
case 8: 
this.filter.push({property: p, filter: {
test: function (v) {return v}}})
break
case 9: 
this.filter.push({property: null, filter: {
script: c.value,test: function (e) {return CalFolder.sandbox.run(this, e, true)}}})
break}}},get ADD () {return 1},get MOVE () {return 2},get DELETE () {return 3},get GET () {return 4},onOperationComplete: function (cal, status, type, id, detail) {
if (--this._pending == 0) {
if (this._caller) this._caller.folderComplete()}},onGetResult: function (cal, status, type, detail, count, data) {
var ok = []
for each (var e in data) {
var w = new CalFolder.entry(e)
var pass = true
for each (var f in this.filter) {
pass = f.filter.test(f.property? w.getProperty(f.property) : e)
if (!pass) break}
if (pass) ok.push(e)}
this.entries += ok.length
if (this._caller) this._caller.entries(cal, status, type, detail, ok.length, ok)},QueryInterface: function (i) {
if (i.equals(Components.interfaces.nsISupports)
|| i.equals(Components.interfaces.calIOperationListener))
return this
throw Components.results.NS_ERROR_NO_INTERFACE},toString: function () {
return "[object CalFolder.folder " + this.res.Value + "]"}},composite: {
_folders: [],_cc: null,_ll: null,_pending: NaN,_unique: null,init: function () {
this._cc = window.getDisplayComposite()
window.gDisplayComposite = this},folder: function (res, add) {
var v = res.Value
if (add) {
for each (var f in this._folders) if (f && f.res.Value == v) return
this._folders.push(CalFolder.folders[res.Value])}
else {
var a = []
for each (var f in this._folders) if (f && f.res.Value != v) a.push(f)
this._folders = a}},calendar: function (cal, add) {},entries: function (cal, status, type, detail, count, data) {
if (!this._folders[1]) {
this._ll.onGetResult(cal, status, type, detail, count, data)}
else {
var ok = []
for (var i = 0; i < count; ++i) {
var e = data[i]
var id = e.getProperty("UID") + "|" + e.getProperty("RECURRENCE-ID")
if (!this._unique[id]) ok.push(e), this._unique[id] = true}
this._ll.onGetResult(cal, status, type, detail, ok.length, ok)}},folderComplete: function () {
if (--this._pending == 0) this._ll.onOperationComplete(null, 0, null, null, null)},addCalendar: function (c) {this._cc.addCalendar(c)},removeCalendar: function (u) {this._cc.removeCalendar(u)},getCalendar: function (u) {return this._cc.getCalendar(u)},get calendars () {return this._cc.calendars},get defaultCalendar () {return this._cc.defaultCalendar},set defaultCalendar (v) {this._cc.defaultCalendar = v},get prefPrefix () {return this._cc.prefPrefix},set prefPrefix (v) {this._cc.prefPrefix = v},get ITEM_FILTER_COMPLETED_YES () {return this._cc.ITEM_FILTER_COMPLETED_YES},get ITEM_FILTER_COMPLETED_NO () {return this._cc.ITEM_FILTER_COMPLETED_NO},get ITEM_FILTER_COMPLETED_ALL () {return this._cc.ITEM_FILTER_COMPLETED_ALL},get ITEM_FILTER_TYPE_TODO () {return this._cc.ITEM_FILTER_TYPE_TODO},get ITEM_FILTER_TYPE_EVENT () {return this._cc.ITEM_FILTER_TYPE_EVENT},get ITEM_FILTER_TYPE_JOURNAL () {return this._cc.ITEM_FILTER_TYPE_JOURNAL},get ITEM_FILTER_TYPE_ALL () {return this._cc.ITEM_FILTER_TYPE_ALL},get ITEM_FILTER_ALL_ITEMS () {return this._cc.ITEM_FILTER_ALL_ITEMS},get ITEM_FILTER_CLASS_OCCURRENCES () {return this._cc.ITEM_FILTER_CLASS_OCCURRENCES},get name () {return this._cc.name},set name (v) {this._cc.name = v},get type () {return this._cc.type},get uri (v) {return this._cc.uri},set uri (v) {this._cc.uri = v},get readOnly () {return this._cc.readOnly},set readOnly (v) {this._cc.readOnly = v},addObserver: function (o) {this._cc.addObserver(o)},removeObserver: function (o) {this._cc.removeObserver(o)},addItem: function (i, l) {this._cc.addItem(i, l)},modifyItem: function (i1, i0, o, l) {this._cc.modifyItem(i1, i0, o, l)},deleteItem: function (i, l) {this._cc.deleteItem(i, l)},getItem: function (i, l) {this._cc.getItem(i, l)},getItems: function (pf, pn, ps, pe, pl) {
this._ll = pl
this._unique = {}
this._pending = this._folders.length
for each (var fdr in this._folders) fdr.getItems(pf, pn, ps, pe, null)},get suppressAlarms () {return this._cc.suppressAlarms},set suppressAlarms (v) {this._cc.suppressAlarms = v},refresh: function () {this._cc.refresh()},QueryInterface: function (i) {return this._cc.QueryInterface(i)},toString: function () {return "[object CalFolder.composite]"}},toString: function () {
return "[object CalFolder]"}}
addEventListener(
"load",function () {CalFolder.init()},true)
_dump = dump
dump = function () {}
